#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_event_detail.pl
# !*-------------------------------------------------------------------------

$| = 1;
$P = "dbamon_event_detail.pl";
require "cgi_handlers.pl";

$maxrows       = 500;

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

# Require the DBI module and the DBD::mysql driver
use DBI;
require "cgi_handlers.pl";

# General parms required
##$DBdir         = "/var/opt/apache/htdocs/cftasks";
##$modlockfile   = "$DBdir/modlock";
##$entlockfile   = "$DBdir/entlock";
##$conlockfile   = "$DBdir/conlock";
##$modfile       = "$DBdir/modEntries";
##$cfteamFile    = "$DBdir/cfteam";
##$entityFile    = "$DBdir/entities";

chop($date     = `date`);

$database = "dbamon";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  $dbms = "oracle";
}

#-----------------------------------------------------------------------------
sub displayError {
   local($errorMsg) = @_;

   print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body><font face=$font>";

   print "<h2> The following database error occured - $date</h2>";
   print "<hr noshade>";
   print "</hr noshade>";
   print "<h4> $errorMsg</h4>";
   $sqlerror = $DBI::errstr;
   print "<br>SQL statement: $statement";
   print "<br>SQL error: $sqlerror";

   &PrintLinks;

   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub connectDB 
{
  # Connect to the Mysql database
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &displayError('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub selectDataDetail
#-----------------------------------------------------------------------------
{
  $s_time = time;

  if ($i_type eq "D")
  {
    $statement  = "
    select 
      to_char(ts,'YYYY/MM/DD-HH24:MI:SS'), 
      dbms,
      msgid,
      title,
      text,
      sev
    from 
      dbamon.event_history 
    where 
      dbamonmode like 'prod%'
      and to_char(ts,'YYYY/MM/DD') = '$i_stamp'
    order by
      2, 4, 1 desc ";
  }
  else
  {
    $statement  = "
    select 
      to_char(ts,'YYYY/MM/DD-HH24:MI:SS'), 
      dbms,
      msgid,
      title,
      text,
      sev
    from 
      dbamon.event_history 
    where 
      dbamonmode like 'prod%'
      and to_char(ts,'YYYY/MM/DD-HH24') = '$i_stamp'
    order by
      2, 4, 1 ";
  }

  # Create the SQL SELECT statement
  ##print "<pre>statement=$statement</pre>\n";

  $sth = $dbh->prepare($statement) ||
          &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;
  print "<font size=2> - Query elapsed time: $elapsed seconds.</font><hr>\n";

  print "<h3> Event Detail (All Events)</h3>\n";
  print "<table border=3 width=80% >\n";
  print "<tr bgcolor=slate><th>Sev<th>DBMS<th>Instance<th>Timestamp<th>Event MsgID - Text\n";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;

    $ts    = $Data[0];
    $dbms  = $Data[1];
    $msgid = $Data[2];
    $title = $Data[3];
    $text  = $Data[4];
    $sev   = $Data[5];

    $color = "white";
    if ($sev eq "C") { $color = "pink";   $fcolor = "black"}
    if ($sev eq "W") { $color = "yellow"; $fcolor = "black"}
    if ($sev eq "I") { $color = "cyan";   $fcolor = "black" }
    if ($sev eq "U") { $color = "lime";   $fcolor = "black"}

    $dbmscolor = "black";
    if ($dbms eq "MSSQL")    { $dbmscolor = "green"; }
    if ($dbms eq "Oracle")   { $dbmscolor = "red"; }
    if ($dbms eq "OracleNT") { $dbmscolor = "darkred"; }
    if ($dbms eq "Informix") { $dbmscolor = "blue"; }

    print "<tr><td colspan=99><hr>\n" if $dbms ne $lastdbms && $lastdbms ne "";

    print "<tr bgcolor=$color>
      <td nowrap><font size=2 color=$fcolor><b>$sev</font>
      <td nowrap><font size=2 color=$dbmscolor><b>$dbms</font>
      <td nowrap><font size=2 color=$fcolor><b>$title</font>
      <td nowrap><font size=2 color=$fcolor><b>$ts</font>
      <td nowrap><font size=2 color=$fcolor><b>$msgid - $text</font></font>\n";
  
    $lastdbms = $dbms;
  }

  print "</table>\n";
  print "<hr><i>Rows Selected: $selectcount</i>\n";
}



#-----------------------------------------------------------------------------
sub selectDataSummary
#-----------------------------------------------------------------------------
{
  $s_time = time;

  if ($i_type eq "D")
  {
    $statement  = "
    select 
      dbms,
      msgid,
      title,
      text,
      sev,
      count(*)
    from 
      dbamon.event_history 
    where 
      dbamonmode like 'prod%'
      and to_char(ts,'YYYY/MM/DD') = '$i_stamp'
    group by
      dbms,
      msgid,
      title,
      text,
      sev
    having
      count(*) >= 3
    order by
      6 desc, 3 ";
  }
  else
  {
    $statement  = "
    select 
      dbms,
      msgid,
      title,
      text,
      sev,
      count(*)
    from 
      dbamon.event_history 
    where 
      dbamonmode like 'prod%'
      and to_char(ts,'YYYY/MM/DD-HH24') = '$i_stamp'
    group by
      dbms,
      msgid,
      title,
      text,
      sev
    having
      count(*) >= 3
    order by
      6 desc, 3 ";
  }

  # Create the SQL SELECT statement
  ##print "<pre>statement=$statement</pre>\n";

  $sth = $dbh->prepare($statement) ||
          &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;
  print "<font size=2> - Query elapsed time: $elapsed seconds.</font><hr>\n";

  print "<h3> Event Summary (Duplicate Events Having >= 3 Occurances)</h3>\n";
  print "<table border=3 width=80% >\n";
  print "<tr bgcolor=slate><th>Event<br>Count<th>Sev<th>DBMS<th>Instance<th>Event MsgID - Text\n";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;

    $dbms  = $Data[0];
    $msgid = $Data[1];
    $title = $Data[2];
    $text  = $Data[3];
    $sev   = $Data[4];
    $count = $Data[5];

    $color = "white";
    if ($sev eq "C") { $color = "pink";   $fcolor = "black"}
    if ($sev eq "W") { $color = "yellow"; $fcolor = "black"}
    if ($sev eq "I") { $color = "cyan";   $fcolor = "black" }
    if ($sev eq "U") { $color = "lime";   $fcolor = "black"}

    $dbmscolor = "black";
    if ($dbms eq "MSSQL")    { $dbmscolor = "green"; }
    if ($dbms eq "Oracle")   { $dbmscolor = "red"; }
    if ($dbms eq "OracleNT") { $dbmscolor = "darkred"; }
    if ($dbms eq "Informix") { $dbmscolor = "blue"; }

    ##print "<tr><td colspan=99><hr>\n" if $dbms ne $lastdbms && $lastdbms ne "";

    print "<tr bgcolor=$color>
      <td nowrap><font size=2 color=$fcolor><b>$count</font>
      <td nowrap><font size=2 color=$fcolor><b>$sev</font>
      <td nowrap><font size=2 color=$dbmscolor><b>$dbms</font>
      <td nowrap><font size=2 color=$fcolor><b>$title</font>
      <td nowrap><font size=2 color=$fcolor><b>$msgid - $text</font></font>\n";
  
    $lastdbms = $dbms;
  }

  print "</table>\n";
  print "<hr><i>Rows Selected: $selectcount</i>\n";
}


#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   print "Signal=$Signal\n";
   exit(0);
}

sub error_html {
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
      
}

sub custom_html {

   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

###############################################################################
# Attempt to make sure that no meta characters are entered in the form.
#------------------------------------------------------------------------------

sub CheckForEvilness
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}


############## Main  ##########################
$logfile = "/tmp/dbamon_event_detail.log";
unlink($logfile);
chop($CurrentDate = `date`);

&get_request;

@words = split(/,/,$ARGV[0]);
$i_type  = $words[0];
$i_stamp = $words[1];

$zclient = $ENV{'REMOTE_HOST'};
##system("echo ' ' | mailx -s '$P ($zclient) $i_type $i_stamp [AUTO]' bill.border\@thecompany.com");

open(LOG, ">>$logfile" );
print LOG "$CurrentDate - $P i_type=$i_type i_stamp=$i_stamp \n";
print LOG `env`;

print "Content-type: text/html\n\n
  <title>DBAmon Event Detail - $i_stamp</title>
  <body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
  <table width=700><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=700>
  <tr bgcolor=wheat><td><font face=$font size=5>
      <center>Event Detail - $i_stamp ($i_type)</center>
  </table>";

print "<hr><font size=2>Retrieving Data ($i_type,$i_stamp) - Please wait ...</font>\n";

#---- Connect to DB
&connectDB;

#---- Create summary report
&selectDataSummary;

#---- Create detail report
&selectDataDetail;

close(LOG);
exit 0;
