#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# ------------------------------------------------------------------------------
# Script   - dbamon_text.pl (The main script)
# Author   - Bill Border / AIT Database Americas
# Revision - 1.0 
# ------------------------------------------------------------------------------
$| = 1;
chop($P = `basename $0`);

# Require the DBI module and the DBD::mysql driver
use DBI;
require "cgi_handlers.pl";

chop($date = `date +%Y/%m/%d-%H:%M:%S`);

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}
$font = "arial" if ! $font;

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
}

#-----------------------------------------------------------------------------
#
# Subroutines
#
#-----------------------------------------------------------------------------

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    return "bgcolor=white";
  }
  else
  {
    $lastbg = 1;
    return "bgcolor=#f2f2f2";
  }
}

#-----------------------------------------------------------------------------
sub error
#-----------------------------------------------------------------------------
{
  local($errorMsg) = $_[0];

  ##print "Content-type: text/html\n\n";
  print "<head><title> Fatal Error</title></head>";
  print "<body>";

  print "<hr><table bgcolor=pink><tr><td><h3>Fatal Error: $errorMsg</h3>";
  $sqlerror = $DBI::errstr;
  &msg("SQL Statement: $sql");
  &msg("SQL Error: $sqlerror");
  print "</table><hr>"; 
  print "</body>";
  print "</html>";

  exit(1);
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "<br><font size=2>$date ${P} | <b>$msgmsg</b></font>\n";
}

#------------------------------------------------------------------------------
sub tableDump 
#------------------------------------------------------------------------------
{
  #---- future use
  $whereclause = ""; 
  $tns_connect = 0; 

  if ($tns_connect != 1)
  {
    &connectDB(1);
  }
  else
  {
    &connectDBRemote;
  }

  if ($table eq "" && $canned_query)
  {
    if ($canned_query eq "ID" && $canned_value ne "")
    {
      if ($dbamon_repos eq "O") 
      {
	$sql_local = "select 
	  category, 
	  parm, 
	  value, 
	  to_char(zdate,'YYYY/MM/DD-HH24:MI:SS') as zdate
	from dbamon.instance_details
	  where instance_key = '$canned_value'
	order by
	  1, 2, 3, 4"; 
      }
      else
      {
	$sql_local = "select 
	  category, 
	  parm, 
	  value, 
	  dbamon.dateconvert_19(zdate) as zdate
	from dbamon.instance_details
	  where instance_key = '$canned_value'
	order by
	  1, 2, 3, 4"; 
      }
    }
  }
  elsif ($table ne "" && $canned_query eq "RM")
  {
    #---- fill vars 
    
    $sql_local = "select * from $table order by 1, 2"; 

    #---- TESTing
    $rmt_host = "slums03"; 
    $rmt_sid  = "NELLIE"; 
    $rmt_port = "1521";
    $rmt_user = $user;
    $rmt_pw   = $passwd;
    $tns_connect = 1; 
  }
  else
  {
    #---- Precoded order by's
    $orderby = "order by system,instance" if $table eq "instances"; 

    $sql_local = "select * from dbamon.$table $whereclause $orderby "; 
  }

  &msg("DEBUG - running sql_local=$sql_local"); 


  &msg("Running sql_local=<u>$sql_local</u>"); 

  $sth = $dbh->prepare($sql_local) || &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $rows_between_heading = 30;
  $column_max = 3;
  $did_heading = 0; 
  $rowcount = 0; 

  print "<p><table border=0 bgcolor=linen>\n"; 

  while($rowhash = $sth->fetchrow_hashref('NAME_uc'))
  {
    $rowcount++;

    if ($did_heading != 1)
    {
      print "<tr bgcolor=slate>\n"; 
      print "<th nowrap><font size=2>Row<br>Number\n"; 

      foreach $key (sort keys %{$rowhash} ) 
      {
        print "<th nowrap><font size=2>$key\n"; 
        $colcount++;
      }
      $did_heading = 1;
      print "<th nowrap><font size=2>Row<br>Number\n" if $colcount > $column_max; 
    }

    $did_heading = 0 if $rowcount / $rows_between_heading == int($rowcount / $rows_between_heading); 

    $bg = &bg; 
    print "<tr $bg>\n"; 
    print "<td nowrap><font size=2><u>${rowcount}.</u>\n"; 

    foreach $key (sort keys %{$rowhash} ) 
    {
      print "<td nowrap><font size=2>$rowhash->{$key}\n"; 
    }

    print "<td nowrap align=right><font size=2><u>${rowcount}.</u>\n" if $colcount > $column_max;
  }

  print "</table>\n"; 

  &msg("Found $rowcount rows"); 
}

#-----------------------------------------------------------------------------
sub displayHeading 
#-----------------------------------------------------------------------------
{
  $links_include = `cat /opt/dbamon/lib/trans_links.txt`;

  print "Content-type: text/html\n\n
  <title>DBAmon Table Dumper</title>
  <body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
  <table width=750><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=750>
  <tr bgcolor=wheat><td><font face=$font size=5>
      <center>Repository Table Dumper</center>
  </table>

  <table width=750>
  <tr>

   $links_include

  </table><hr>
  <font size=2><b>Note:</b> To export the data displayed here to an 
  Excel spreadsheet, right click anywere on the HTML table.<br>
  ";
}

#-----------------------------------------------------------------------------
sub displayError 
#-----------------------------------------------------------------------------
{
   local($errorMsg) = @_;

   print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body>";

   print "<h2> The following database error occured - $date</h2>";
   print "<hr noshade>";
   print "</hr noshade>";
   print "<h4> $errorMsg</h4>";
   $sqlerror = $DBI::errstr;
   print "<br>SQL statement: $sql";
   print "<br>SQL error: $sqlerror";

   &PrintLinks;

   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub connectDBOld
#-----------------------------------------------------------------------------
{
  &msg("Connecting to DB $data_source:$database"); 
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &displayError('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub connectDBRemotex
#-----------------------------------------------------------------------------
{
  &msg("Connecting to Remore DB $rmt_sid\@$rmt_host"); 
  $dbh = DBI->connect("DBI:Oracle:","$rmt_user/$rmt_pw@(DESCRIPTION=( ADDRESS=(PROTOCOL=TCP) (Host=$rmt_host)(Port=$rmt_port))(CONNECT_DATA=(SID=$rmt_sid))(GLOBAL_NAMES=false ))", "") || &displayError('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

#---- Read arguments
@words = split(/\\\?/,$ARGV[0]);

$table        = $words[0];
$canned_query = $words[1];
$canned_value = $words[2];

#---- Display html header
&displayHeading;

&msg("$P Starting - table=$table canned_query=$canned_query canned_value=$canned_value"); 

##system("echo ' ' | mailx -s '$P - $canned_value' border\@dba.it.thecompany.com"); 

#---- Dump the table
&tableDump;

&msg("Done");

exit 0;
