# -----------------------------------------------------------------------------
sub oraapUp
{
  ($thishost) = @_;

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    return;
  }

  # Start with a clean slate
  $up[$thishost] = "";

  $useridap[$thishost]       = "." if $useridap[$thishost] eq "";
  $comn[$thishost]           = "." if $comn[$thishost] eq "";
  $minproc_apache[$thishost] = "." if $minproc_apache[$thishost] eq "";
  $forms_orahome[$thishost]  = "." if $forms_orahome[$thishost] eq "";

  $cmd = "$probe[$thishost] up $useridap[$thishost] $minproc_apache[$thishost] $comn[$thishost] $forms_orahome[$thishost] $oraapfs[$thishost]";
  ##print "cmd=$cmd \n";

  $must_connect = 1;
  
  &remsh($cmd,$tmpfl3,$thishost);
  ##system("cat $tmpfl3");

  if ($up[$thishost] eq "N")     # Remsh error
  {
    &logit("(Connect Error)",$thishost);
    return;
  }

  if ($t_mustbeup[$thishost] eq "Y")
  {
    $sev = "C";
  }
  else
  {
    $sev = "I";
  }

  $procmissing = 0;
  undef @fsentries;

  open(TMPFL3, "$tmpfl3"  ) || &error_msg("Can't open input $tmpfl3 - $!");
  while(<TMPFL3>)
  {
    &parse;
    if ($F1 eq "MODE" && $F2 ne "getconf")
    {
      $os_mode[$thishost] = $F2
    }

    if ($F1 eq "Physical_RAM_MB:")  { $hw_memory[$thishost] = $F2 }
    if ($F1 eq "Num_Processors:")   { $hw_processors[$thishost] = $F2 }
    if (substr($F1,0,4) eq "9000")
    {
      @words = split(/\//,$F0);
      $model = $words[2];
      $hw_model[$thishost] = $model;
    }
    if ($F1 eq "HP-UX")
    {
      $os_version[$thishost] = substr($F3,2);
    }
    if ($F4 eq "VER:")   { $sw_version[$thishost] = $F5 }

    # Alerts
    if ($F4 eq "PGMERROR:") 
    {
      &event($sev,$thishost,"Program Error: $F0","ProgErr","DBA700",$tmpfl3);
    }
    if ($F4 eq "PROCCHECK_EXCEPTION:") 
    {
      $proctype = $F5;
      $proccnt  = $F6;
      $procthr  = $F7;
      &event($sev,$thishost,"$proctype Process(es) Missing - Found: $proccnt MinThreshold: $procthr","Proc$proctype","DBA701",$tmpfl3);
      $procmissing = 1;
    }
    if ($F4 eq "TCFSTATUS_EXCEPTION:") 
    {
      $tcfrc = $F5;
      &event($sev,$thishost,"TCF Status Exception - rc: $tcfrc","TCFStat","DBA702",$tmpfl3);
      $procmissing = 1;
    }
    if ($F4 eq "FORMSSERVER_EXCEPTION:") 
    {
      $pcnt = $F5;
      &event($sev,$thishost,"Forms Server f60srvm Exception - Process Count: $pcnt","FrmSrv","DBA703",$tmpfl3);
      $procmissing = 1;
    }
    if ($F4 eq "FORMSSERVERMX_EXCEPTION:") 
    {
      $pcnt = $F5;
      &event($sev,$thishost,"Forms Server f60webmx Exception - Process Count: $pcnt","FrmSrvMX","DBA704",$tmpfl3);
      $procmissing = 1;
    }
    if ($F4 eq "LISTENER_EXCEPTION:") 
    {
      $list = $F5;
      &event($sev,$thishost,"Listener $list Not TNSPING-Able ","ListErr","DBA705",$tmpfl3);
      $procmissing = 1;
    }
    if ($F4 eq "FSCHECK:") 
    {
      $envvar = $F5;
      $fsname = $F6;
      $pct    = $F7;
      $size   = $F8;
      $used   = $F9;
      $fssev  = $F10;
      if ($fssev ne "")
      {
        &event($fssev,$thishost,"FS: $fsname ${pct}% Full - envvar=$envvar fssev=$fssev ","FS${envvar}Full","DBA706",$tmpfl3);
      }
      push @fsentries, "<tr><td><b>$envvar<td>$fsname<td align=right>$pct<td align=right>$size<td align=right>$used<td>$fssev";
    }

    # Collect metrics
    if ($F4 =~ /PROCCHECK/) 
    {
      if ($F5 eq "Apache")
      {
        $proccnt_apache = $F6;
        $procthr_apache = $F7;
      }
    }
    if ($F4 =~ /FORMSSERVER_/) 
    {
      $proccnt_forms = $F5;
    }
    if ($F4 =~ /FORMSSERVERMX_/) 
    {
      $proccnt_formsmx = $F5;
    }
  }
  close(TMPFL3);

  if ($sw_version[$thishost] ne "")
  {
    if ($sw_version[$thishost] lt $ver_oracleapps_low  || $ver_oracleapps_low eq "" ) { $ver_oracleapps_low  = $sw_version[$thishost] }
    if ($sw_version[$thishost] gt $ver_oracleapps_high || $ver_oracleapps_high eq "") { $ver_oracleapps_high = $sw_version[$thishost] }
  }

  if ($procmissing)
  {
    $up[$thishost] = "N";
  }
  else
  {
    $up[$thishost] = "Y";
    &logit("OK",$thishost);
  }

  &logDetails($thishost,"<h3>Server/OracleApps Details</h3>");
  &logDetails($thishost,"<table border=1>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
  &logDetails($thishost,"<tr><td><b>OS Type:<td align=right>$os[$thishost]");
  &logDetails($thishost,"<tr><td><b>OS Version:<td align=right>$os_version[$thishost]");
  &logDetails($thishost,"<tr><td><b>OS Mode:<td align=right>$os_mode[$thishost]<td>(32, 64 or Blank)");
  &logDetails($thishost,"<tr><td><b>Server Type:<td align=right>$hw_model[$thishost]");
  &logDetails($thishost,"<tr><td><b>Server Memory (MB):<td align=right>$hw_memory[$thishost]");
  &logDetails($thishost,"<tr><td><b>Server Processor Count:<td align=right>$hw_processors[$thishost]");
  &logDetails($thishost,"<tr><td><b>OracleApps Version:<td>$sw_version[$thishost]");
  &logDetails($thishost,"<tr><td><b>OracleApps Apache Process Count:<td align=right>$proccnt_apache");
  &logDetails($thishost,"<tr><td><b>OracleApps Apache Min Process Threshold:<td align=right>$procthr_apache");
  &logDetails($thishost,"<tr><td><b>OracleApps Forms Server f60srvm Process Count:<td align=right>$proccnt_forms");
  &logDetails($thishost,"<tr><td><b>OracleApps Forms Server f60webmx Process Count:<td align=right>$proccnt_formsmx");
  &logDetails($thishost,"</table><hr>");
  
  &logDetails($thishost,"<h3>OracleApps File Systems (From DBC OraApps_FS_Check: Entries)</h3>");
  &logDetails($thishost,"<table border=1>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Env. Var. Name<th>FS Name<th>% Full <th>FS Size<th>FS Used<th>Event Sev.</tr>");
  foreach (@fsentries) 
  {
    &logDetails($thishost,$_);
  }
  &logDetails($thishost,"</table><hr>");

  &history_dummy($thishost);

  $backup_method_long[$thishost] = "N/A"; 

  # Read SWVer data

  foreach (@swver_data)
  {
    next if $_ !~ /^$dbmsout[$thishost]/;
    @words = split;
    $this_family = $words[1];
    $this_minver = $words[2];

    ##print "$titleraw[$thishost] $sw_version[$thishost] - Found this_family=$this_family this_minver=$this_minver\n";

    # Continue only if this is OUR family
    next if $sw_version[$thishost] !~ /^$this_family/;

    $z = length($this_minver);
    if (substr($sw_version[$thishost],0,$z) lt $this_minver)
    {
      &event("U",$thishost,"$dbmsout[$thishost] Version $sw_version[$thishost] is older than the minimum 'good' version ($this_minver) for this family ($this_family)","SWVER-OldVer","DBA652");
    }
  }
}
# -----------------------------------------------------------------------------
1;
